/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Message-area routines.  (Message saving, message header stuff,         *
 *  E)nter function, matrix credit debiting.)                              *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <dos.h>
#include <errno.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include "prog.h"
#include "ffind.h"
#include "alc.h"
#include "max.h"
#include "max_msg.h"

static char *fbgets(char *s,int n,FILE *fp);
static void pascal Check_For_Origin(int *last,char *temp);
void pascal Scan_LastRead_Pointer(void);
void pascal Scan_Msg_Numbers(int get_high);

/**************************** MAX_MSG1.C ***********************************/

int pascal Save_Msg(struct _msg *msg,FILE *upfile,int local_msg,int msgnum,int chg)
{
  int msgfile,
      first,
      ret,
      unlink_it,
      freed,
      found_tear,
      last_isblstr,
      last_len,
      x;

  int sv1,
      sv2;

  char msgname[PATHLEN],
       temp[PATHLEN],
       last_char,
       ch;

  unsigned char *s;

  char zero='\0';          /* A NULL which we can write to a file */

  ret=unlink_it=freed=FALSE;

  Last_Msg();   /* Make sure msgs[] wasn't freed while in the BORED editor *
                 * menu...                                                 */

  Puts(s(savedmsg1));

  /* Re-scan the messages in this area, just in case someone entered a msg  *
   * in another partition of a multitasking environment, so we don't        *
   * overwrite theirs.                                                      */

  if (!msgnum)
    Scan_Msg_Numbers(msgs ? FALSE : TRUE);

  if (num_msg==0 && (area.attrib[class] & ECHOMAIL)) /* Don't write to the HW  */
    high_msg=1;                                   /* marker if we're in an  */
                                                  /* echo area.             */
  Printf(s(savedmsg2),msgnum ? msgnum : high_msg+1);

  sprintf(msgname,d_msg,msgnum ? msgnum : high_msg+1);

  if ((msgfile=sopen(msgname,O_WRONLY | O_BINARY | O_CREAT | O_TRUNC,SH_DENYNONE,
                    S_IREAD | S_IWRITE))==-1)
  {
    Printf(errwriting,msgnum ? msgnum : high_msg+1);
    logit(cantopen,msgname);
    ret=TRUE;
  }
  else
  {
    sv1=msg->dest_net;
    sv2=msg->dest;

    if ((prm.flags2 & FLAG2_gate) && zoneto != 0 &&
        zoneto != prm.address[0].Zone)
    {
      msg->dest_net=prm.address[0].Zone;
      msg->dest=zoneto;
    }

    if (write(msgfile,(char *)msg,sizeof(struct _msg)) != sizeof(struct _msg))
    {
      Printf(errwriting,msgnum ? msgnum : high_msg+1);
      logit(cantwrite,msgname);
      ret=TRUE;
    }
    else
    {
      /* Restore header information, so the Insert_Message_Kludges() will  *
       * know what to put in the ^aINTL kludge                             */

      msg->dest_net=sv1;
      msg->dest=sv2;

      Insert_Message_Kludges(msgfile,msg,zoneto,pointto);

      found_tear=0; /* Checking for origin lines */

      /* Now we write the actual text (contained in the array of arrays    *
       * screen[][]).  Make sure to differentiate between hard and soft    *
       * carriage returns!  Also, if the upfile parameter is NULL, then it *
       * means that we're writing the message from our internal fs or line *
       * editor.  If it is non-null, then it is a pointer to a file        *
       * (probably an uploaded or locally-entered message) that we should  *
       * use instead.                                                      */

      if (upfile)
      {
        first=TRUE;
        last_char=0;
        last_len=0;
        last_isblstr=FALSE;

        while (fbgets(temp,PATHLEN,upfile))
        {
          Trim_Line(temp);

          if (!local_msg) 
          {
            /* Make sure the message isn't too long */

            if (ftell(upfile) > 8000L)
              break;

            /* Strip out any control characters */

            for (s=temp;*s;s++)
              if (*s < 32)
                *s=' ';
              else *s=(Highbit_Allowed() ? *s : nohibit[(unsigned char)*s]);
          }

          /* Now insert the hard/soft CR for the previous line, based on   *
           * this line's attributes...                                     */

          if (!first)
          {
            /* If last line had a trailing space, or if the first char     *
             * on this line is a letter.                                   */
            
            if (*temp > 32 && !last_isblstr && last_len >= 60)
            {
              if (! is_wd(last_char)) /* Make sure wrapped line has space */
              {
                ch=' ';
                write(msgfile,&ch,1);
              }
              
              ch=SOFT_CR;
            }
            else ch=HARD_CR;

            write(msgfile,&ch,1);
          }

          first=FALSE;

          Check_For_Origin(&found_tear,temp);

          write(msgfile,temp,strlen(temp));
          
          if (*temp)
            last_char=temp[strlen(temp)-1];
          else last_char='\0';
          
          last_len=strlen(temp);
          last_isblstr=isblstr(temp);
        }

        /* Add the final CR */

        ch='\r';
        write(msgfile,&ch,1);
      }
      else
      {
        for (x=1;x <= num_lines;x++)
        {
          /* See if it's a hard or soft carriage return, and output the     *
           * correct text.                                                  */

          Check_For_Origin(&found_tear,screen[x]+1);

          write(msgfile,&screen[x][1],strlen(&screen[x][1]));
          write(msgfile,&screen[x][0],1);
        }
      }

      /* Add the origin line */

      if (found_tear != 2 && (area.attrib[class] & ECHOMAIL))
        Write_Origin_Line(msgfile);

      if (write(msgfile,&zero,1) != 1)  /* The terminating NUL... */
      {
        Printf(errwriting,msgnum ? msgnum : high_msg+1);
        ret=unlink_it=TRUE;
      }
      else
      {
        if (num_msg+1 >= MAX_MSG)
        {
          Puts(toomanymessages);
          logit(ltoomanymessages,area.msgpath,MAX_MSG);
          ret=TRUE;
        }
        else
        {
          /* Free message here, in case it's using some memory which we    *
           * need for msgs[].                                              */

          if (upfile==NULL && !freed)
          {
            Free_All();
            freed=TRUE;
          }

          if (!msgs)  /* OK, try the allocate now */
          {
            if ((msgs=(int *)malloc(sizeof(int)*MAX_MSG))==NULL)
              logit(mem_nmsga);           /* If NULL, we're screwed... */
            else Scan_Msg_Numbers(FALSE); /* Else it's looking good... */
          }

          if (!msgnum && msgs)
            msgs[num_msg++]=++high_msg;    /* Update the in-memory message chain */

          if (!eqstri(usr.name,msg->from))
            logit(s(log_msgfrom),usr.name,msg->from);

          if (area.attrib[class] & SYSMAIL)
            sprintf(temp," (%d:%d/%d.%d)",zoneto,msg->dest_net,msg->dest,pointto);
          else *temp='\0';

          logit(chg ? chgdmsg : msgto,msg->to,temp,Area_Name(usr.msg),msgnum ? msgnum : high_msg);

          Puts("\n" CLEOL);

          if (area.attrib[class] & SYSMAIL)  /* Handle charging and matrix costs! */
          {
            written_matrix=TRUE;
            Handle_Matrix_Charges(zoneto,msg->dest_net,msg->dest,TRUE);
          }
          else if (area.attrib[class] & ECHOMAIL)
            written_echomail=TRUE;
          else written_local=TRUE;


          /* Set the bit field, for the echo tosslog */

          if (*area.msgname)
            BitOn(echo_written_in,(int)(Index_of_Area(area.areano)/(long)sizeof(struct _area)));
        }
      }
    }

    close(msgfile);           /* And we're (almost) done! */
  }

  /* Free the message text, in case we didn't get around to it above */

  if (upfile==NULL && !freed)           
  {
    Free_All();
    freed=TRUE;
  }

  if (upfile && !local_msg && ftell(upfile) >= 4096L)
    Puts(s(msg_tlong));

  if (unlink_it)
    unlink(msgname);
  else bstats.msgs_written++;

  return ret;
}


static void pascal Check_For_Origin(int *found_tear,char *temp)
{
  if (*found_tear==0 && strncmp(temp,"---",3)==0)
    *found_tear=1;
  else if (*found_tear==1 && strncmp(temp," * Origin:",10)==0)
    *found_tear=2;
  else if (*found_tear != 2)
    *found_tear=0;
}


/* This function is the main routine that is called by all of the other     *
 * message-entry functions -- It prompts the user for the To/From/Subject,  *
 * and handles things such as netmail credit and others.                    */

int pascal Get_Msg_Attr(struct _msg *msg)
{
  struct _newnode newnode;
  struct _node nnode;

  char temp[PATHLEN];

  int ret,
      zone,             /* \                                 */
      net,              /*  \ Destination of current         */
      node,             /*  / message.  Temp. holding area.  */
      point,            /* /                                 */
      first,
      x;

  inc=TRUE;
  zone=prm.address[0].Zone;
  net=prm.address[0].Net;
  node=prm.address[0].Node;
  point=0;
  first=TRUE;

  if ((area.attrib[class] & UREALNAME) && *usr.realname)
    strcpy(msg->from,usr.realname);

  Clear_KBuffer();

  if (zfree(area.msgpath) < 10000L)
  {
    Puts(s(warn_splow));
    Press_ENTER();
  }

  if (timeleft() <= 5)
  {
    Printf(s(warn_mleft),timeleft());

    if (GetyNAnswer(s(strt_any),0)==NO)
      return -1;
  }

  if ((area.attrib[class] & NOPRIVATE) && (area.attrib[class] & NOPUBLIC) &&
      !GEPriv(usr.priv,ASSTSYSOP))
  {
    sprintf(temp,"%sREADONLY.?BS",area.msgpath);

    if (fexist(temp))
    {
      *strrchr(temp,'.')='\0';
      Display_File(0,NULL,temp);
    }
    else
    {
      Puts(s(rd_only));
      Press_ENTER();
    }
    ret=-1;
  }
  else
  {
    if (area.attrib[class] & NOPRIVATE || area.attrib[class] & NOPUBLIC)
      item=1;
    else item=0;

    ret=0;

BeginMsgEnter:

    if (graph != GRAPHICS_none)
    {
      realgoto=TRUE;

      if (usr.formfeed)
        Puts(CLS);
      else
      {
        Puts(avt_home);

        Printf("\x16\x19\x03"   "\n" CLEOL   "%c",
               usr.len-(usr.help==HOTFLASH ? 1 : 0)-((prm.flags & FLAG_statusline) ? 1 : 0));
      }

      Puts("\x16\x08\x03\x01" CYAN);
    }
    else Puts(CLS);

    Puts(s(this_be));

    if (area.attrib[class] & ECHOMAIL)
    {
      if (area.attrib[class] & NOPRIVATE)
      {
        Puts(sp_public);
        msg->attr &= ~MSGPRIVATE;
      }
      else if (area.attrib[class] & NOPUBLIC)
      {
        Puts(sp_private);
        msg->attr |= MSGPRIVATE;
      }
      else Puts(s(pl_n));

      Puts(s(th_e));
    }
    else
    {
      if (area.attrib[class] & NOPRIVATE)
      {
        Puts(sp_public);
        msg->attr &= ~MSGPRIVATE;
      }
      else if (area.attrib[class] & NOPUBLIC)
      {
        Puts(sp_private);
        msg->attr |= MSGPRIVATE;
      }
      /* else print nothing */
    }

    Printf(s(this_area),Area_Name(usr.msg));

    if (graph != GRAPHICS_none)
    {
      /* Prompt for netmail attributes */

      if ((area.attrib[class] & SYSMAIL) && first)
      {
        Ask_Message_Attrs(msg);

        /* Clear down to bottom of screen */

        if (usr.help != HOTFLASH)
          Printf("\x16\x08\x03\x01\x16\x19\x03"   "\n" CLEOL   "%c",usr.len-3-((prm.flags & FLAG_statusline) ? 1 : 0));
      }

      first=FALSE;

      Msg_Enter_Dsp_Pvt(msg);

      /* Net/node is blank at beginning because we'll need to enter the    *
       * TO: field anyways, which temporarily blanks out the dest. addr    *
       * field.                                                            */

      Msg_Enter_Dsp_To(msg,blank_str,&zone,&net,&node,&point);
      Msg_Enter_Dsp_Subj(msg);

      if (area.attrib[class] & ANON_OK)
        Msg_Enter_Dsp_From(msg);

      Printf(s(edt_hlpline),area.attrib[class] & ANON_OK ? '\x08' : '\x07');

      while (item != -1)
      {
        switch (item)
        {
          case 0:

            /* Don't allow user to set private bit in a forced pvt or public
               area...  If we're in one of those areas, increment item
               so we go on to the next field.                               */

            if (area.attrib[class] & NOPUBLIC || area.attrib[class] & NOPRIVATE)
              item++;
            else
            {
              Printf(s(gmsg_l1),pressentertoskip);

              switch (ret=Msg_Enter_Get_Pvt(msg))
              {
                case -1:
                  goto EndMsgEnter;

                case -2:
                  ret=0;
                  item=0;
                  goto BeginMsgEnter;
              }
            }
            break;

          case 1:
            Printf(s(gmsg_l2),
                   (!(prm.flags & FLAG_no_ulist) && !(area.attrib[class] & SYSMAIL)) ?
                   s(gmsg_l2p5) : blank_str,
                   pressentertoskip);

            if ((ret=mdm_getsp(msg->to,min(34,(usr.width-current_col)-1)))==-1)
              goto EndMsgEnter;

            if (eqstri(msg->to,"Sysop") && !(area.attrib[class] & SYSMAIL))
            {
              strcpy(msg->to,PRM(sysop));
              Msg_Enter_Dsp_To(msg,netnode,&zone,&net,&node,&point);
            }
            else
            {
              if (eqstr(msg->to,qmark) && !(prm.flags & FLAG_no_ulist) &&
                  !(area.attrib[class] & SYSMAIL) && item==2)
              {
                realgoto=FALSE;
                Puts(CLS);

                /* If user didn't abort userlist, then pause for an ENTER, *
                 * so the screen clear doesn't wipe everything.            */

                if (UserList() != -1)
                  Press_ENTER();

                mknl(msg->to);

                item=1;
                goto BeginMsgEnter;
              }

              /* Make sure user exists if a pvt. message in a local area! */
              if (!isnl(msg->to) && !(area.attrib[class] & SYSMAIL) &&
                  !(area.attrib[class] & ECHOMAIL) && (msg->attr & MSGPRIVATE) &&
                  !IsInUserList(msg->to))
              {
                mknl(msg->to);

                Printf(YELLOW "\x07\x16\x08%c\x01%s\n" WHITE,
                       area.attrib[class] & ANON_OK ? '\x0a' : '\x09',
                       userdoesntexist);

                Press_ENTER();

                for (x=0x08+((area.attrib[class] & ANON_OK) ? 1 : 0);x < 0x0c;x++)
                  Printf("\x16\x08%c\x01\x16\x07",x);

                realgoto=TRUE;
                item=1;
              }
            }
            break;

          case 2:
            /* If this is a netmail area, prompt for destination addr... */
            if (area.attrib[class] & SYSMAIL)
            {
              Printf(s(gmsg_l3),0x13+strlen(msg->to));

              if ((ret=mdm_getsp(netnode,min(16,(usr.width-current_col)-1)))==-1)
                goto EndMsgEnter;

              if (isnl(netnode))
                sprintf(netnode,znnp,prm.address[0].Zone,prm.address[0].Net,
                        prm.address[0].Node,prm.address[0].Point);

              if (eqstri(netnode,"/"))
              {
                realgoto=FALSE;
                Puts(CLS);

                if (NetList())
                  Press_ENTER();

                mknl(netnode);

                item=2;
                goto BeginMsgEnter;
              }
              else if (*netnode && (netnode[strlen(netnode)-1]=='/' &&
                       (*netnode+1)) || netnode[strlen(netnode)-1]=='#')
              {
                realgoto=FALSE;
                Puts(CLS);

                if (! eqstri(netnode,"#"))
                  Parse_NetNode(netnode,&zone,&net,&node,&point);

                if (NodeList(zone,net))
                  Press_ENTER();

                if (eqstri(netnode,"#"))
                  mknl(netnode);

                item=2;
                goto BeginMsgEnter;
              }

              if (item != 1) /* If item==1, we're going to erase line anyways... */
                Msg_Enter_Dsp_To(msg,netnode,&zone,&net,&node,&point);
            }
            else if (inc)
              item++; /* Otherwise, skip over this field! */
            else item--;
            break;

          case 3:
            Printf("\x16\x08\x01\x01" YELLOW CLEOL "\x16\x08\x02\x01"
                   BLKONWHIT CLEOL "%s" CYAN "\x16\x08\x06\x12",
                   pressentertoskip);

            if ((ret=mdm_getsp(msg->subj,min(70,(usr.width-current_col)-1)))==-1)
              goto EndMsgEnter;
            break;

          case 4:
            if (area.attrib[class] & ANON_OK)
            {
              Puts(s(gmsg_l4));

              if ((ret=mdm_getsp(msg->from,min(34,(usr.width-current_col)-1)))==-1)
                goto EndMsgEnter;

              if (isnl(msg->from))
                strcpy(msg->from,((area.attrib[class] & UREALNAME) && *usr.realname) ?
                       usr.realname : usr.name);
            }
            else item=-1;
            break;

          case 5:
            item=-1;
            break;
        }
      }
    }
    else
    {
      Printf(WHITE "%s" CYAN "\n\n",area.msginfo);

      sprintf(temp,"%sWHY_PVT",PRM(misc_path));

      if (! (area.attrib[class] & NOPRIVATE || area.attrib[class] & NOPUBLIC))
      {
        if (msg->attr & MSGPRIVATE)
          x=GetYnhAnswer(temp,s(apvt),0);
        else x=GetyNhAnswer(temp,s(apvt),0);

        if (x==YES)
          msg->attr |= MSGPRIVATE;
        else msg->attr &= ~MSGPRIVATE;

        Putc('\n');
      }

      Clear_KBuffer();

      if (area.attrib[class] & SYSMAIL)
      {
        Ask_Message_Attrs(msg);

        while (1)
        {
          if (! *netnode)
          {
            if (isnl(linebuf))
              Puts(s(edmsg));

            OpusGets(netnode,s(naddr));
          }

          if (eqstri(netnode,"/"))
          {
            Putc('\n');
            NetList();
            *netnode='\0';
            continue;
          }
          else if (*netnode && (netnode[strlen(netnode)-1]=='/' &&
                   (*netnode+1)) || netnode[strlen(netnode)-1]=='#')
          {
            if (! eqstri(netnode,"#"))
              Parse_NetNode(netnode,&zone,&net,&node,&point);

            Putc('\n');
            NodeList(zone,net);
            *netnode='\0';
            continue;
          }

          if (! *netnode)
            sprintf(netnode,znnp,prm.address[0].Zone,prm.address[0].Net,
                    prm.address[0].Node,prm.address[0].Point);

          Parse_NetNode(netnode,&zone,&net,&node,&point);

          sprintf(netnode,znnp,zone,net,node,point);

          Printf("%s, " GREEN,netnode);

          if (ReadNode(zone,net,node,prm.nlver==6 ? (void *)&newnode : (void *)&nnode))
          {
            Printf("%0.34s, %0.20s\n\n",prm.nlver==6 ? newnode.SystemName : nnode.name,
                                        prm.nlver==6 ? newnode.MiscInfo : nnode.city);
            break;
          }
          else
          {
            Puts(unlisted_node);
            Puts(n_n);

            if (GEPriv(usr.priv,prm.unlisted_priv))
              break;
            else *netnode='\0';
          }
        }
      }

      while (1)
      {
        if (isnl(msg->to))
        {
          strcpy(msg->to,qmark);

          while (eqstr(msg->to,qmark))
          {
            if (!(prm.flags & FLAG_no_ulist) && !(area.attrib[class] & SYSMAIL))
              Puts(s(bed_lu));

            Puts(s(eto));
            OpusGetsNH(msg->to,min(34,(usr.width-current_col)+1),NULL);

            if (eqstr(msg->to,qmark) && !(prm.flags & FLAG_no_ulist))
            {
              Putc('\n');
              UserList();
              Putc('\n');
            }
            else if ((ret=isblstr(msg->to)) != 0)
            {
              ret=-1;
              goto EndMsgEnter;
            }
          }

          if (!(area.attrib[class] & SYSMAIL) && eqstri(msg->to,"Sysop"))
          {
            Printf(s(mroute_sysop),PRM(sysop));
            strcpy(msg->to,PRM(sysop));
          }
          else
          {
            /* Make sure user exists if a pvt. message in a local area! */
            if (! isnl(msg->to) && !(area.attrib[class] & SYSMAIL) &&
                !(area.attrib[class] & ECHOMAIL) && (msg->attr & MSGPRIVATE))
            {
              if (! IsInUserList(msg->to))
              {
                item=1;
                mknl(msg->to);

                Printf(WHITE "%s\n\n",userdoesntexist);
                continue;
              }
            }
          }
        }
        else Printf(s(nowto),msg->to);

        break;
      }

      Printf(CYAN "%s " YELLOW,
             msg->attr & (MSGFILE | MSGFRQ | MSGURQ) ? files_colon :
                                                        subj_colon);

      if (! *msg->subj)
        OpusGetsNH(msg->subj,min(70,(usr.width-current_col)+1),NULL);
      else
      {
        Printf("%s\n" CYAN,msg->subj);

        Puts(s(keep_subj));
        Puts(s(new_subj));

        OpusGetsNH(temp,min(70,(usr.width-current_col)+1),NULL);

        if (*temp)
          strcpy(msg->subj,temp);
      }

      if (area.attrib[class] & ANON_OK)
      {
        Puts(s(pefon));
        Puts(s(n_from));
        OpusGetsNH(msg->from,min(34,(usr.width-current_col)+1),NULL);
      }
    }

    if (isnl(msg->to) || isnl(msg->subj))
      ret=-1;

    if ((area.attrib[class] & SYSMAIL) && isblstr(netnode) &&
        !GEPriv(usr.priv,prm.unlisted_priv))
    {
      Puts(unlisteddest);
      Press_ENTER();
      ret=-1;
    }

  EndMsgEnter:

    if ((area.attrib[class] & ANON_OK) && isblstr(msg->from))
      strcpy(msg->from,((area.attrib[class] & UREALNAME) && *usr.realname) ?
             usr.realname : usr.name);

    realgoto=FALSE;
  }

  if (ret != -1)
  {
    zoneto=zone;
    msg->dest_net=net;
    msg->dest=node;
    pointto=point;

    fancier_str(msg->to);
    fancier_str(msg->from);

    if (area.attrib[class] & SYSMAIL)
      ret=Check_Credit(zone,net,node);

    if (((msg->attr & MSGFILE) || (msg->attr & MSGURQ)) && !fexist(msg->subj))
    {
      Puts(s(a_noex));
      Press_ENTER();
    }
  }

  return ret;
}


void pascal Msg_Enter_Dsp_Pvt(struct _msg *msg)
{
  Printf(s(gmsg_pvt),msg->attr & MSGPRIVATE ? yep : nope);
}

void pascal Msg_Enter_Dsp_To(struct _msg *msg,char *netnode,int *zone,int *net,int *node,int *point)
{
  struct _node nnode;
  struct _newnode newnode;

  Printf(s(gmsg_to),fancier_str(msg->to));

  if (*netnode)
  {
    Parse_NetNode(netnode,zone,net,node,point);

    sprintf(netnode,znnp,*zone,*net,*node,*point);

    Printf(s(at_netaddr),
           0x13+strlen(msg->to),netnode);

    Printf("\x16\x08\x05%c" GREEN,0x17+strlen(msg->to)+strlen(netnode));

    if (ReadNode(*zone,*net,*node,prm.nlver==6 ? (void *)&newnode : (void *)&nnode))
    {
      Printf("%0.*s, %0.*s",
             usr.width-(0x14+strlen(msg->to)+strlen(netnode)),
             prm.nlver==6 ? newnode.SystemName : nnode.name,
             usr.width-(0x17+strlen(msg->to)+strlen(netnode)+
             strlen(prm.nlver==6 ? newnode.SystemName : nnode.name))-3,
             prm.nlver==6 ? newnode.MiscInfo : nnode.city);
    }
    else Puts(unlisted_node);
  }
}


void pascal Msg_Enter_Dsp_Subj(struct _msg *msg)
{
  Printf("\x16\x08\x06\x01" CYAN "%s\x16\x08\x06\x12" CYAN "%s" CLEOL,
         (msg->attr & (MSGFILE | MSGFRQ | MSGURQ)) ? files_colon : subj_colon,
         msg->subj);
}

void pascal Msg_Enter_Dsp_From(struct _msg *msg)
{
  Printf(s(gmsg_from),msg->from);
}

void pascal Ask_Message_Attrs(struct _msg *msg)
{
  int x;

  for (x=1;x < 16;x++) /* x != 0, since we don't want to mess with MSGPRIVATE! */
  {
    if (GEPriv(usr.priv,prm.msg_assume[x]) ||
        (GEPriv(usr.priv,prm.msg_ask[x]) && GetyNAnswer(msg_ask[x],0)==YES))
      msg->attr |= (1 << x);
    else msg->attr &= ~(1 << x);
  }

  msg->attr |= MSGLOCAL;
}



int pascal IsInUserList(char *name)
{
  struct _usr *user;

  int userbbs,
      x,y;

  /* If we can't allocate, non-critical error, so report success. */

  if ((user=malloc(sizeof(struct _usr)*USR_SEARCH))==NULL)
    return TRUE;

  if ((userbbs=shopen(PRM(user_file),O_BINARY | O_RDONLY))==-1)
    logit(cantopen,PRM(user_file));
  else
  {
    /* Read it in a chunk at a time */
    while ((y=read(userbbs,(char *)user,sizeof(struct _usr)*USR_SEARCH)/sizeof(struct _usr)) != 0)
    {
      for (x=0;x < y;x++)
        if (eqstri(name,user[x].name) && !(user[x].flag & UFLAG_deleted))
        {
          close(userbbs);
          free(user);
          return TRUE;
        }
    }
  }

  close(userbbs);
  free(user);
  return FALSE;
}


void pascal Parse_NetNode(char *netnode,int *zone,int *net,int *node,int *point)
{
  char *p;

  if (zone)
    *zone=prm.address[0].Zone;

  if (net)
    *net=prm.address[0].Net;

  if (node)
    *node=0;

  if (point)
    *point=0;

  p=netnode;

  /* If we have a zone (and the caller wants the zone to be passed back).. */

  if (strchr(netnode,':') && zone)
  {
    *zone=atoi(p);
    p=firstchar(p,colon,2);
  }

  /* If we have a net number... */

  if (p && strchr(netnode,'/') && net)
  {
    *net=atoi(p);
    p=firstchar(p,slash,2);
  }

  /* We *always* need a node number... */

  if (p && node)
    *node=atoi(p);

  /* And finally check for a point number... */

  if (p && strchr(netnode,'.') && point)
  {
    p=firstchar(p,dot,2);

    if (p)
      *point=atoi(p);
    else *point=0;
  }
}







void pascal Insert_Message_Kludges(int msgfile,struct _msg *msg,int zoneto,int pointto)
{
  char temp[PATHLEN];

  if (prm.address[area.origin_aka].Point)
    sprintf(temp,".%d",prm.address[area.origin_aka].Point);
  else mknl(temp);

  if (prm.address[area.origin_aka].Node != -1)
  {
    lprintf(msgfile,"\x01MSGID: %u:%d/%d%s %08lx\r",
            prm.address[area.origin_aka].Zone,
            prm.address[area.origin_aka].Net,
            prm.address[area.origin_aka].Node,
            temp,
            verylongtime(&msg->date_written));

    if (*orig_msgid)
      lprintf(msgfile,"\x01REPLY: %s\r",orig_msgid);
  }

  /* International zonegating */
  if (zoneto && zoneto != prm.address[0].Zone && (area.attrib[class] & SYSMAIL))
    lprintf(msgfile,msg_intl,zoneto,msg->dest_net,msg->dest,prm.address[0].Zone,
            msg->orig_net,msg->orig);

  /* Now take care of point addresses */

  if (prm.address[area.origin_aka].Point && (area.attrib[class] & SYSMAIL))
    lprintf(msgfile,msg_fmpt,prm.address[area.origin_aka].Point);

  if (pointto && (area.attrib[class] & SYSMAIL))
    lprintf(msgfile,msg_topt,pointto);

  if (! eqstri(msg->from,usr.name) &&
      ((!(prm.flags & FLAG_norname) && !(area.attrib[class] & NREALNAME)) ||
       ((prm.flags & FLAG_norname) && (area.attrib[class] & NREALNAME))))
    lprintf(msgfile,"\x01REALNAME: %s\r",usr.name);
}


void pascal Write_Origin_Line(int outmsgfile)
{
  char pointstr[PATHLEN];
  int x;

  x=(prm.address[0].Point ? 1 : area.origin_aka);

  if (prm.address[area.origin_aka].Point)
    sprintf(pointstr,".%d",prm.address[area.origin_aka].Point);
  else mknl(pointstr);

  /* Now tack on OUR origin */

  lprintf(outmsgfile,tearline,
          /* tear */
          us,tear_ver,

          /* origin */
          area.origin,
          prm.address[area.origin_aka].Zone,
          prm.address[area.origin_aka].Net,
          prm.address[area.origin_aka].Node,
          pointstr,

          /* seen-by */
          prm.address[x].Net,
          prm.address[x].Node);
}


int pascal Check_Credit(int zone,int net,int node)
{
  struct _newnode newnode;
  struct _node nnode;

  if (! (area.attrib[class] & SYSMAIL))
    return 0;
  
  if (! ReadNode(zone,net,node,prm.nlver==6 ? (void *)&newnode : (void *)&nnode))
  {
    if (! GEPriv(usr.priv,prm.unlisted_priv))
    {
      Puts(unlisteddest);
      Press_ENTER();
      return -1;
    }

    if (prm.nlver==6)
      newnode.Cost=prm.unlisted_cost;
    else nnode.cost=prm.unlisted_cost;
  }

  if (usr.debit+(prm.nlver==6 ? newnode.Cost : nnode.cost) > usr.credit)
  {
    Puts(s(ncredit));
    Press_ENTER();
    return -1;
  }

  return 0;
}


/**************************** MAX_MSG2.C ***********************************/

            
int pascal Msg_Enter(void)
{
  struct _msg msg;
  int aborted,
      x;

  isareply=FALSE;

  Blank_Msg(&msg);
  mknl(netnode);
  mknl(orig_msgid);

  if (Get_Msg_Attr(&msg)==-1)
    aborted=TRUE;
  else
  {
    logit(usingeditor);
    x=Editor(&msg,-1);
    logit(outofeditor);

    if (x != ABORT)
    {
      if (x==LOCAL_EDIT)
        aborted=FALSE;
      else aborted=Save_Msg(&msg,NULL,FALSE,0,0);
    }
    else aborted=TRUE;
  }

  if (aborted)
  {
    Puts(msg_aborted);
    return -1;
  }

  return 0;
}





int pascal Msg_Enter_Get_Pvt(struct _msg *msg)
{
  int recycle,
      ch;

  for (recycle=TRUE;recycle;)
  {
    recycle=FALSE;
    
    Goto('\x04','\x12');

    ch=Mdm_getcw();

    switch (ch=toupper(ch))
    {
      case 0:
        switch (Mdm_getcw())
        {
          case 80:            /* DOWN */
            inc=TRUE;
            item++;
            break;
        }
        break;

      case '\x18':            /* CtrlX/Down */
        inc=TRUE;
        item++;
        break;

      case '\x1b':
        switch (Mdm_getcw())
        {
          case '[':
          case 'O':
            switch (Mdm_getcw())
            {
              case 'A':
              case 'C':
              case 'D':
                break;

              case 'B':
                inc=TRUE;
                item++;
                break;
            }
            break;

          case '\x1b':
            item=-1;
            return -1;
        }
        break;

      case '?':
        Puts(CLS);
        Display_File(0,NULL,"%sWHY_PVT",PRM(misc_path));
        Press_ENTER();
        return -2;

      case YES:
        msg->attr |= MSGPRIVATE;
        break;

      case NO:
        msg->attr &= ~MSGPRIVATE;
        break;

      case ' ':
        if (msg->attr & MSGPRIVATE)
          msg->attr &= ~MSGPRIVATE;
        else msg->attr |= MSGPRIVATE;
        break;

      case '\x0d':
        inc=TRUE;
        item++;
        break;
        
      default:
        recycle=TRUE;
    }
  }

  Msg_Enter_Dsp_Pvt(msg);

  return 0;
}



static char *fbgets(char *s,int n,FILE *fp)
{
  char *o;
  
  int ch;
  
  for (o=s;n-- && (ch=fgetc(fp)) != EOF && ch != '\n';)
  {
    if (ch=='\r')
    {
      if ((ch=fgetc(fp)) != '\n')
        ungetc(ch,fp);
      
      break;
    }
    else *s++=(char)ch;
  }
  
  *s='\0';
  
  return (ch==EOF ? NULL : o);
}


int pascal Handle_Matrix_Charges(int zone,int net,int node,int total)
{
  struct _node nnode;
  struct _newnode newnode;

  int x;

  if (! ReadNode(zone,net,node,prm.nlver==6 ? (void *)&newnode : (void *)&nnode))
  {
    /* What the hell happened to our node? */
    if (! GEPriv(usr.priv,prm.unlisted_priv))
      return -1;

    if (prm.nlver==6)
      newnode.Cost=prm.unlisted_cost;
    else nnode.cost=prm.unlisted_cost;
  }

  x=(prm.nlver==6 ? newnode.Cost : nnode.cost);

  if (x)  /* If there was a charge for this message */
  {
    if (total)
    {
      Puts(s(ms_1));
      Printf(s(ms_2),usr.credit);
      Printf(s(ms_3),usr.debit);
      Printf(s(ms_4),x);
    }

    usr.debit += x;

    if (usr.debit > usr.credit)
      return -1;

    if (total)
    {
      Printf(s(ms_5),usr.credit-usr.debit);

      logit(s(log_charge),x);

      if (usr.credit-usr.debit < 100)
        logit(s(log_bal),usr.credit-usr.debit);
    }
  }

  return 0;
}
